
/********************************** (C) COPYRIGHT *********************************
* File Name          : LEDCTRL.C
* Author             : WCH
* Version            : V1.3
* Date               : 2016/06/24
* Description        : CH559DMAʽʵLEDƣʹU̸
                       ֧UȲ
**********************************************************************************/

/*********************************ͷļ**************************************/
#include <stdio.h>
#include <string.h>
#include "CH559.H"                                                    //CH559ͷļ
#include "DEBUG.H"                                                    //ģ
#include "DEBUG.C"
#include "ROOT_UDISKIF.H"                                                   //U̽ӿģ
#include "ROOT_UDISKIF.C"

#pragma  NOAREGS

/*********************************ͷļ**************************************/
#define   ScreenLength      1024                                            //Ļĳȣ(bit)
#define   ScreenWidth       16                                              //ĻĿȣ(bit)
#define   UnicodeSize       2048                                            //ScreenLength*ScreenWidth/8 Uжȡַ
#define   LargeUnicodeSize  1024                                            //ֽ
#define   SingleSendSize    128                                             //ScreenLength/8 LEDDMAη͵ݳ

#ifndef DEBUG                                                               //ӡϢ
#define DEBUG 1
#endif

// #if LargeUnicodeSize>=UnicodeSize
// UINT8X LEDBuffer[CountUnicode]  _at_ 0x0000;                             //LED DMAͻ
// #else
UINT8X LEDBuffer[LargeUnicodeSize]  _at_ 0x0000;                            //LED DMAͻ
UINT8X LEDBuffer1[LargeUnicodeSize]  _at_ (0x0000+LargeUnicodeSize);        //LED DMAͻ
// #endif

sbit LA   = P2^0;
sbit LB   = P2^1;
sbit LC   = P2^2;
sbit LD   = P2^3;
sbit EN   = P2^4;
sbit STB  = P2^5;
#define EN_L( )       { EN  = 0; }                             
#define EN_H( )       { EN  = 1; }  
#define STB_L( )      { STB = 0; }                            
#define STB_H( )      { STB = 1; }
#define LINE0         { LD=0;LC=0;LB=0;LA=0; } 
#define LINE1         { LD=0;LC=0;LB=0;LA=1; }
#define LINE2         { LD=0;LC=0;LB=1;LA=0; }
#define LINE3         { LD=0;LC=0;LB=1;LA=1; }
#define LINE4         { LD=0;LC=1;LB=0;LA=0; }
#define LINE5         { LD=0;LC=1;LB=0;LA=1; }
#define LINE6         { LD=0;LC=1;LB=1;LA=0; }
#define LINE7         { LD=0;LC=1;LB=1;LA=1; }
#define LINE8         { LD=1;LC=0;LB=0;LA=0; }
#define LINE9         { LD=1;LC=0;LB=0;LA=1; }
#define LINE10        { LD=1;LC=0;LB=1;LA=0; }
#define LINE11        { LD=1;LC=0;LB=1;LA=1; }
#define LINE12        { LD=1;LC=1;LB=0;LA=0; }
#define LINE13        { LD=1;LC=1;LB=0;LA=1; }
#define LINE14        { LD=1;LC=1;LB=1;LA=0; }
#define LINE15        { LD=1;LC=1;LB=1;LA=1; }


/******************************SPI0 Flash**************************************/
/*******************************************************************************
* Function Name  : InitSPI_Host( void )
* Description    : SPI0ģʽʼ
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/
void	InitSPI_Host( void )
{
    SPI0_SETUP &=~(bS0_MODE_SLV | bS0_BIT_ORDER) ;                            // óģʽ
    SPI0_CTRL = bS0_SCK_OE | bS0_MOSI_OE;                                     //дĬϲд䣬ʹbS0_DATA_DIR
                                                                              //ôݺԶһֽڵʱӣڿշ	
    P1_DIR |= (bMOSI | bSCK | bSCS| bPWM3 );			                            //bMOSI bSCK bSCSΪ
    P1_DIR &= ~bMISO;
    SPI0_CK_SE = 0x02;	                                                      //ƵΪ6M
//	SPI0_STAT = 0xFF;                                                         // жϱ־
//	IE_SPI0 = 1;
}

/*******************************************************************************
* Function Name  : SPI0_MASTER_Trans
* Description    : һֽ
* Input          : buffer - 
* Output         : None
* Return         : None
*******************************************************************************/
void SPI0_MASTER_Trans( UINT8 dat )
{
    SPI0_DATA = dat;
    while( S0_FREE == 0 );                                                    //ȴݷ
}

/*******************************************************************************
* Function Name  : SPI0_MASTER_Recv
* Description    : һֽ
* Input          : None
* Output         : None
* Return         : յ
*******************************************************************************/
UINT8 SPI0_MASTER_Recv( void )
{
    SPI0_DATA = 0xFF;
    while(  S0_FREE == 0 );                                                   //ȴݻ	
    return SPI0_DATA;
}

/*******************************************************************************
* Function Name  : Read_Status_Register
* Description    : ȡ״̬Ĵ,״̬Ĵֵ,Ϊ֤ٶȣԲú
* Input          : None
* Output         : None
* Return         : SPI0_DATA -Ĵ״ֵ̬
*******************************************************************************/
UINT8 Read_Status_Register( void )   
{   
    UINT8 byte = 0;
    SCS = 0 ;                                                                  //ʹ豸 
    SPI0_DATA = 0x05;                                                          //Ͷ״̬Ĵ 
    while( S0_FREE == 0 );                                                     //ȴݷ  
    SPI0_DATA = 0xFF; 
    while(  S0_FREE == 0 );                                                    //ȡ״̬Ĵ  
    SCS = 1 ;                                                                  //ֹ豸    
    return SPI0_DATA;   
}
   
/*******************************************************************************
* Function Name  : Wait_Busy
* Description    : ȴоƬ(ִByte-Program, Sector-Erase, Block-Erase, Chip-Erase)
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Wait_Busy( void )   
{   
    while ((Read_Status_Register())&0x01 == 0x01 )                              //waste time until not busy   
          Read_Status_Register( );   
}

/*******************************************************************************
* Function Name  : WRSR
* Description    : ״̬Ĵдһֽ
* Input          : byte -д
* Output         : None
* Return         : None
*******************************************************************************/
void WRSR( UINT8 byte )   
{   
    SCS = 0 ;                                                                  //ʹ豸 
    SPI0_MASTER_Trans(0x01);                                                   //д״̬Ĵ   
    SPI0_MASTER_Trans(byte);                                                   //ıĴBPxBPL (ֻ2,3,4,5,7λԸд)   
    SCS = 1 ;                                                                  //ֹ豸  
}
 
/*******************************************************************************
* Function Name  : WREN
* Description    : дʹ,ͬʹд״̬Ĵ 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WREN( void )   
{   																	                                         //SCSسͻʹAIN3
   SCS = 0 ;         
   SPI0_MASTER_Trans(0x06);                                                    //WREN  
   SCS = 1 ;             
}

/*******************************************************************************
* Function Name  : WREN_Check
* Description    : дǰWELλǷΪ1 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WREN_Check( void )   
{   
    UINT8 byte;   
    byte = Read_Status_Register( );                                             //ȡ״̬register   
    if ((byte&0x02) != 0x02)                                                    //WELλλ   
    {   
        WREN( );                                                                //δ1Ӧ,дʹò 
    }   
}

/*******************************************************************************
* Function Name  : Chip_Erase
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Chip_Erase( void )   
{                          
    WREN_Check();   
    SCS = 0 ;            
    SPI0_MASTER_Trans(0x60);                                                    // Chip Erase (60h or C7h)   
    SCS = 1 ;  
    Wait_Busy();   
}

/*******************************************************************************
* Function Name  : FlashRead
* Description    : ȡʼַSingleSendSizeֽڵ.ضȡ,ٶ 
* Input          : Dst -Destination Address 000000H - 1FFFFFH
                   buffer ջʼַ
* Output         : None
* Return         : None
*******************************************************************************/
void FlashRead(UINT32 Dst,PUINT8 buffer)    
{   
    UINT8 i;    
    SCS = 0 ;                                                                   //enable device  
    SPI0_DATA = 0x03;                                                           //read command 
    while( S0_FREE == 0 );                                                      //ȴݷ 
    SPI0_DATA = ((Dst & 0xFFFFFF) >> 16);                                       //send 3 address bytes
    while( S0_FREE == 0 );                                                      //ȴݷ 
    SPI0_DATA = ((Dst & 0xFFFF) >> 8);                                       
    while( S0_FREE == 0 );                                                      	
    SPI0_DATA = Dst & 0xFF;                                       
    while( S0_FREE == 0 ); 
    for(i=0;i<SingleSendSize;i++)
    {                                                                           //ȴݷ 
        SPI0_DATA = 0xFF;
        while(  S0_FREE == 0 );                                                  
        *(buffer+i) = SPI0_DATA;			
    }				 
    SCS = 1 ;                                                                   //disable device   
} 

/*******************************************************************************
* Function Name  : Byte_Program
* Description    : д
* Input          : Dst  -Destination Address 000000H - 1FFFFFH
*                  byte -Ҫд
* Output         : None
* Return         : None
*******************************************************************************/
void Byte_Program(UINT32 Dst, UINT8 byte)
{
    WREN();
    SCS = 0 ;                                                                    //оƬʹ 
    SPI0_MASTER_Trans(0x02);                                                     //дָ 
    SPI0_MASTER_Trans(((Dst & 0xFFFFFF) >> 16));                                 //3ֽڵַ 
    SPI0_MASTER_Trans(((Dst & 0xFFFF) >> 8));
    SPI0_MASTER_Trans(Dst & 0xFF);
    SPI0_MASTER_Trans(byte);                                                     //Ҫд
    SCS = 1 ;
    Wait_Busy();
}

/*******************************************************************************
* Function Name  : CopyData2Flash(UINT16 Num,UINT16 Addr)
* Description    : ֶӦFlash
* Input          : UINT16 Num дFlashֽ
                   UINT16 Addr дFlashʼַ
* Output         : None
* Return         : None
*******************************************************************************/
void CopyData2Flash(UINT16 Num,UINT16 Addr)
{
		UINT16 i;

		for(i=0;i<Num;i++)
		{
            Byte_Program( Addr+i ,LEDBuffer1[i] );                                  
		}
}	
/****************************SPI0 Flash END*************************************/

/*****************************ѡIO**************************************/
/*******************************************************************************
* Function Name  : InitLED(void)
* Description    : LED
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/
void InitLED() 
{
    P2_DIR = 0xff;                                                    
    P3_DIR = 0xff;                                                      
    //P4_DIR = 0xff;                                                     
    PORT_CFG |= bP2_DRV | bP3_DRV;
    EN_H( );
    STB_L( );
    LED_CTRL  =  0x00|bLED_OUT_EN |bLED_BIT_ORDER;      
    LED_CK_SE=0x06;
}

/*******************************************************************************
* Function Name  : Showline(UINT8 LineNum) 
* Description    : LED
* Input          : UINT8 LineNum 
* Output         : None
* Return         : None
*******************************************************************************/
void Showline(UINT8 LineNum)                                     
{
    switch(LineNum)                                                     
	  {
         case  0: LINE0;break;
         case  1: LINE1;break;
         case  2: LINE2;break;
         case  3: LINE3;break;
         case  4: LINE4;break;
         case  5: LINE5;break;
         case  6: LINE6;break;
         case  7: LINE7;break;
         case  8: LINE8;break;
         case  9: LINE9;break;
         case 10:LINE10;break;
         case 11:LINE11;break;
         case 12:LINE12;break;
         case 13:LINE13;break;
         case 14:LINE14;break;
         case 15:LINE15;break;
         default:break;
    }
}
/******************************IO end*******************************************/

/*******************************************************************************
* Function Name  : ReadDisplayFile()
* Description    : ȡUҪʾĺַ(ÿֶӦ2ַ)洢Flash
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void ReadDisplayFile( )        
{
    UINT8 s,i;
    UINT16 len;
	
	WREN( );                                                                     //FLASHдʹ
	WRSR( 0x00 );                                                                //дĴ 
	Chip_Erase( );                                                               //FLASHƬ

    strcpy( mCmdParam.Open.mPathName, "/COMMAND.TXT" );                          //Ҫ򿪵ļ 
    s = CH559FileOpen( );  
    if ( s == ERR_MISS_DIR || s == ERR_MISS_FILE )    
    {
        printf( "Miss File,Please Check the file name...\n" );
    }
    else    
    {
      mCmdParam.ByteLocate.mByteOffset = 602;                                  //ƫָ
      s = CH559ByteLocate();
      mStopIfError( s );
      for(i=0;i<(UnicodeSize/LargeUnicodeSize);i++)                            //ȴLargeUnicodeSize
      {                                                                        //ÿζLargeUnicodeSize
          mCmdParam.ByteRead.mByteCount = LargeUnicodeSize;  
          mCmdParam.ByteRead.mByteBuffer = LEDBuffer1;                         //öļַ
          s = CH559ByteRead( );
          mStopIfError( s );
          printf("%02X  \n",(UINT16)i);
#if DEBUG
          for(len=0;len<LargeUnicodeSize;len++)
          {
              printf("%02X  ",(UINT16)LEDBuffer1[len]);
          }	
#endif					
          CopyData2Flash(LargeUnicodeSize,i*LargeUnicodeSize);                 //дFlash         
      }	
      mCmdParam.ByteRead.mByteCount = UnicodeSize%LargeUnicodeSize;            //ʣֽ  
      mCmdParam.ByteRead.mByteBuffer = LEDBuffer1;                             //öļַ
      s = CH559ByteRead( );
      mStopIfError( s );
#if DEBUG
      for(len=0;len<(UnicodeSize%LargeUnicodeSize);len++)
      {
          printf("%02X  ",(UINT16)LEDBuffer1[len]);
      }	
#endif			
      CopyData2Flash(UnicodeSize%LargeUnicodeSize,i*LargeUnicodeSize);         //дFlash
  } 	
  mCmdParam.Close.mUpdateLen = 0;                                              //ֹļ
  s = CH559FileClose( );                                                       //رļ
  mStopIfError( s );		    
}	

/*******************************************************************************
* Function Name  : SendLeddata(UINT8 lineNum)
* Description    : DMAʽ
* Input          : UINT8 lineNum
* Output         : None
* Return         : None
*******************************************************************************/	
void SendLeddata(UINT8 lineNum)  
{
    UINT8 i,len;
    len = SingleSendSize/2;
    i=0;
	
    if(lineNum%2 == 0)
    {
        LED_DMA = LEDBuffer1; 
        LED_DMA_CN = len;                                                      //DMA˫ֵģ2
        LED_CTRL |=  bLED_DMA_EN;  
        			
        FlashRead((UINT16)SingleSendSize*((lineNum+1)%ScreenWidth),LEDBuffer); //FLASH	
    }
    else
    {
        LED_DMA = LEDBuffer; 
        LED_DMA_CN = len;                                                       //DMA˫ֵģ2 
        LED_CTRL |=  bLED_DMA_EN;	  

        FlashRead((UINT16)SingleSendSize*((lineNum+1)%ScreenWidth),LEDBuffer1);//FLASH				
    }
    while(LED_FIFO_CN||!(LED_STAT&bLED_FIFO_EMPTY));		
    LED_CTRL &= ~ bLED_DMA_EN ;
#if 0
    for(i=0;i<SingleSendSize;i++)
    {
        if(lineNum%2 == 0)
        {
            printf("%02X  ",(UINT16)LEDBuffer[i]);
        }
        else
        {
            printf("%02X  ",(UINT16)LEDBuffer1[i]);            
        }	
    }				
    printf("\n");	
#endif		
}


/*******************************************************************************
* Function Name  : Leddisplay(void)
* Description    : Ļʾ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/	
void Leddisplay( )  
{
    UINT8 i;
#if 0 	
    printf("benin\n");	
#endif
    for(i=0;i<16;i++)
    { 		
		STB_H();
		mDelayuS(2);
		STB_L(); 
		SendLeddata(i);
		EN_L();		 
		Showline(i);
		mDelayuS(500);
        EN_H();			
    } 
}

/*************************************************************************/
void main( )  
{
    UINT8 s,i;
    mDelaymS(30);                                                              //ϵʱ,ȴڲȶ,ؼ          
    mInitSTDIO( );                                                             //Ϊüͨڼʾ
    printf("Start LED contol....\n");
    InitUSB_Host( );
    InitLED( );
    InitSPI_Host( );
    CH559LibInit( );                                                            //ʼCH559֧Uļ
    FoundNewDev = 0;  
    UIF_DETECT=0;
    FlashRead(0,LEDBuffer1);                                                    //FLASHһе
    while(1)
    {
        if ( UIF_DETECT )                                                       //U豸
        {
            UIF_DETECT = 0;                                                     //жϱ־
            s = AnalyzeRootHub( );                                              //ROOT-HUB״̬
            if( s == ERR_USB_CONNECT )
            {
                FoundNewDev = 1;
            }
            if( FoundNewDev || s == ERR_USB_CONNECT )                           //µUSB豸
            {
                FoundNewDev = 0;
                mDelaymS( 200 );                                                //USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
                s = InitRootDevice( );                                          //ʼUSB豸
                if( s == ERR_SUCCESS )
                {
                    // U̲̣USB߸λUӡȡ豸USBַѡĻȡ֮󵽴˴CH559ӳɺ
                    CH559DiskStatus = DISK_USB_ADDR;
                    for( i = 0; i != 10; i ++ )
                    {
                        s = CH559DiskReady( );
                        if ( s == ERR_SUCCESS )
                        {
                            break;
                        }
                        mDelaymS( 50 );
                    }
                    if( CH559DiskStatus >= DISK_MOUNTED )                       //U׼
                    {
                        printf("Read Command File....\n");
                        ReadDisplayFile();
                        printf("Finish Reading File\n");
                    }
                    else
                    {
                        printf( "U_Disk not ready ERR =%02X\n", (UINT16)s );
                    }
                 }
                 else
                 {
                     printf("U_Disk Init Failed,Please retry again\n");
                 }
             } 
             SetUsbSpeed( 1 );                                                  // ĬΪȫ	
        }
  		Leddisplay( );                                                          //̬ʾ
    }
}



